<!DOCTYPE html>
<html>
<head>
<title>Squashing Commits in Git</title>
<meta  charset="utf-8">
<meta  name="generator" content="Org-mode">
<link href='http://fonts.googleapis.com/css?family=Source+Sans+Pro:400,700&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
            <link href='http://fonts.googleapis.com/css?family=Source+Serif+Pro:400,700&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
            <link href='http://fonts.googleapis.com/css?family=Source+Code+Pro:400,700' rel='stylesheet' type='text/css'>
            <link rel="stylesheet" href="/css/styles.css" type="text/css"/>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
            <script src="/js/magic.js"></script>
            <link rel="icon" href="/img/dragon.svg">
            <link rel="shortcut icon" href="/img/dragon-head.png">
            <meta name="viewport" content="width=device-width, initial-scale=1" />
<script type="text/javascript">
/*
@licstart  The following is the entire license notice for the
JavaScript code in this tag.

Copyright (C) 2012-2013 Free Software Foundation, Inc.

The JavaScript code in this tag is free software: you can
redistribute it and/or modify it under the terms of the GNU
General Public License (GNU GPL) as published by the Free Software
Foundation, either version 3 of the License, or (at your option)
any later version.  The code is distributed WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU GPL for more details.

As additional permission under GNU GPL version 3 section 7, you
may distribute non-source (e.g., minimized or compacted) forms of
that code without the copy of the GNU GPL normally required by
section 4, provided you include this license notice and a URL
through which recipients can access the Corresponding Source.


@licend  The above is the entire license notice
for the JavaScript code in this tag.
*/
<!--/*--><![CDATA[/*><!--*/
 function CodeHighlightOn(elem, id)
 {
   var target = document.getElementById(id);
   if(null != target) {
     elem.cacheClassElem = elem.className;
     elem.cacheClassTarget = target.className;
     target.className = "code-highlighted";
     elem.className   = "code-highlighted";
   }
 }
 function CodeHighlightOff(elem, id)
 {
   var target = document.getElementById(id);
   if(elem.cacheClassElem)
     elem.className = elem.cacheClassElem;
   if(elem.cacheClassTarget)
     target.className = elem.cacheClassTarget;
 }
/*]]>*///-->
</script>
</head>
<body>
<div id="preamble" class="status">
<div id="top-bar" class="gray-gradient">
  <a href="http://www.howardabrams.com" id="portrait">
    <img src="/img/me-circle.png" alt="www.howardism.org"/>
  </a>
  <div id="title">
    <a href="http://www.howardism.org">
      Howardisms
    </a>
  </div>
  <div id="subtitle">
    Babblings of an aging geek in love with the Absurd, his family,
    and his own hubris.... oh, and Lisp.
  </div>
  <div id="search-area">
    <a href="index.xml" id="rss-button" class="button">
      <img src="/img/rss.svg" width="32" alt="RSS" title="Get updates via my RSS Feed."/>
    </a>
    <a href="/formmail/mail?to=howardism" id="mail-button"
       class="button" target="_new">
      <img src="/img/mail.svg" width="32" alt="Mail" title="Mail me a message comment."/>
    </a>
    <form method="get" id="searchform" action="http://www.google.com/search">
      <input type="text" class="field" name="q" id="s" placeholder="Search" title="Use Google to search this site"/>
      <input type="hidden" name="q" value="site:www.howardism.org"/>
    </form>
  </div>
</div>
</div>
<div id="content">
<h1 class="title">Squashing Commits in Git</h1>
<p>
Good Git practice encourages developers to create a history of
<i>useful</i> commits. This essay is a ‘recipe’ for squashing
multiple&#x2026; uh&#x2026; less than helpful commits into a single commit using
the Git&rsquo;s interactive rebase command.
</p>

<p>
Why? Consider this abbreviated history from a typical project:
</p>


<figure>
<p><img src="img/bad-git-commit-example.png" alt="bad-git-commit-example.png">
</p>
</figure>

<p>
In a &ldquo;best case&rdquo; each commit assume a reader familiar with the purpose
and background of the change. In a &ldquo;worse case&rdquo;, it shows some pretty
sloppy commits. Either way, <code>git log</code> is completely useless with these
sorts of commit messages.
</p>

<p>
<b>Note:</b> I am <b>not</b> advocating for you to change your development style
and wait for perfection before committing. On the contrary, make many
commits, but squash the results before pushing the changes.
</p>

<p>
To follow along with this <i>squashing exercise</i>, let&rsquo;s start out with a
fresh git project&#x2026;follow along at home by first creating a directory on
your file system, and issuing a <code>git init</code> within it.<sup><a id="fnr.1" name="fnr.1" class="footref" href="#fn.1">1</a></sup> Then do:
</p>

<div class="org-src-container">

<pre class="src src-sh">$ git checkout -b TICKET-123  <span style="color: #969896; font-style: italic;"># </span><span style="color: #969896; font-style: italic;">Create a local dev branch</span>
Switched to a new branch <span style="color: #8abeb7;">'TICKET-123'</span>
$ <span style="color: #969896; font-style: italic;"># </span><span style="color: #969896; font-style: italic;">edit src/some-code.py</span>
$ git add src/some-code.py
$ git commit -m <span style="color: #8abeb7;">'Added debugging code. To be removed.'</span>
 1 file changed, 1 insertion<span style="color: #c5c8c6;">(</span>+<span style="color: #c5c8c6;">)</span>
$ <span style="color: #969896; font-style: italic;"># </span><span style="color: #969896; font-style: italic;">edit src/some-code.py</span>
$ git commit -a -m <span style="color: #8abeb7;">'Step 2'</span>
 1 file changed, 1 insertion<span style="color: #c5c8c6;">(</span>+<span style="color: #c5c8c6;">)</span>
$ <span style="color: #969896; font-style: italic;"># </span><span style="color: #969896; font-style: italic;">edit src/some-code.py</span>
$ git commit -a -m <span style="color: #8abeb7;">'Found bug. Really? A tab vs. space issue?'</span>
 1 file changed, 1 insertion<span style="color: #c5c8c6;">(</span>+<span style="color: #c5c8c6;">)</span>
$ <span style="color: #969896; font-style: italic;"># </span><span style="color: #969896; font-style: italic;">edit src/some-code.py</span>
$ git commit -a -m <span style="color: #8abeb7;">'Oops. Forgot to remove debugging code.'</span>
 1 file changed, 1 insertion<span style="color: #c5c8c6;">(</span>+<span style="color: #c5c8c6;">)</span>
</pre>
</div>

<p>
Issue a <code>git log</code> and notice that we have four commits that should be
one, with the last commit at the top. Let&rsquo;s start the <i>squashing</i>:
</p>

<div class="org-src-container">

<pre class="src src-sh">$ git rebase -i HEAD~4
</pre>
</div>

<p>
This command<sup><a id="fnr.2" name="fnr.2" class="footref" href="#fn.2">2</a></sup> will pull up your editor &#x2026; and here is where it gets
interesting. The commits to squash are shown at the top, along with
some commentary to help refresh your memory:
</p>


<figure>
<p><img src="img/git-squash-1.png" alt="git-squash-1.png">
</p>
</figure>

<p>
Squash all but the top one by changing the word &ldquo;pick&rdquo; to &ldquo;squash&rdquo;:<sup><a id="fnr.3" name="fnr.3" class="footref" href="#fn.3">3</a></sup>
</p>


<figure>
<p><img src="img/git-squash-2.png" alt="git-squash-2.png">
</p>
</figure>

<p>
<b>Note</b>: Marking a line as <code>squash</code> will merge it with the commit above it
(further back in the history). In our example, we are squashing
everything, so we just need one <code>pick</code> line.
</p>

<p>
Save the file and exit from your editor, and your editor will be
brought back&#x2026;this time to let you clean up the commit
messages. Notice that all the messages are shown, allowing you to
include all the interesting bits from your past development session:
</p>


<figure>
<p><img src="img/git-squash-3.png" alt="git-squash-3.png">
</p>
</figure>

<p>
Clean up and leave only one commit message. Exit from your editor, and
issue a <code>git log</code> to see that you have a nice Git history ready for
framing on the wall, and even submitting for review.
</p>
<div id="footnotes">
<h2 class="footnotes">Footnotes: </h2>
<div id="text-footnotes">

<div class="footdef"><sup><a id="fn.1" name="fn.1" class="footnum" href="#fnr.1">1</a></sup> <p class="footpara">
Here is a cheat-sheet for starting up a blank Git project to
play with:
</p>

<div class="org-src-container">

<pre class="src src-sh"><span style="color: #b294bb;">cd</span> /tmp
mkdir gitstuff
<span style="color: #b294bb;">cd</span> gitstuff
git init
<span style="color: #969896; font-style: italic;"># </span><span style="color: #969896; font-style: italic;">Initialized empty Git repository in /tmp/gitstuff/.git/</span>
touch README
git add README
git commit -m <span style="color: #8abeb7;">"Initialization."</span>
<span style="color: #969896; font-style: italic;"># </span><span style="color: #969896; font-style: italic;">[master (root-commit) f91be73] Initialization.</span>
</pre>
</div>

<p class="footpara">
At this point, you are ready to experiment.
</p></div>

<div class="footdef"><sup><a id="fn.2" name="fn.2" class="footnum" href="#fnr.2">2</a></sup> <p class="footpara">
The <code>rebase</code> command is how we rewrite history, and the <code>-i</code> option
says that we would like to interactively change things. The last
option specifies the <i>parent of the oldest commit</i> we want to squash.
</p>

<p class="footpara">
Huh?
</p>

<p class="footpara">
Allow a brief demonstration. Suppose our <code>git log</code> looked like this:
</p>

<pre class="example">
commit 86de7aebe91cdee0ab91ef65c611962c3eec61b2
Author: Howard Abrams &lt;howard.abrams@gmail.com&gt;
Date:   Thu Oct 23 22:40:36 2014 -0700

    Oops. Forgot to remove debugging code.

commit 464b4adf81f29f85fbf45db1ccf19ebfcc80614f
Author: Howard Abrams &lt;howard.abrams@gmail.com&gt;
Date:   Thu Oct 23 22:40:10 2014 -0700

    Found bug. Really? A tab vs. space issue?

commit 7657715763598aefb4956bc3893ad14ae89da3e9
Author: Howard Abrams &lt;howard.abrams@gmail.com&gt;
Date:   Thu Oct 23 22:39:47 2014 -0700

    Step 2

commit 2b2b2169d20756a4977cf85ededb3d4b9438eb8d
Author: Howard Abrams &lt;howard.abrams@gmail.com&gt;
Date:   Thu Oct 23 22:39:18 2014 -0700

    Added debugging code. To be removed.

commit 55bf21460610c52b5662250c2509a1cd4725a905
Author: Howard Abrams &lt;howard.abrams@gmail.com&gt;
Date:   Thu Oct 23 22:36:37 2014 -0700

    Initializing the project
</pre>

<p class="footpara">
To squash the top four commits, we need to specify the parent of the
oldest commit, <code>2b2b2169d...</code>, which is commit labeled &ldquo;Initializing
the project&rdquo;, and has an ID: <code>55bf21460610c5...</code>
</p>

<p class="footpara">
Sure, we could copy and paste the ID, but we could also specify the
commit by its location <i>from the top</i>.
</p>

<ul class="org-ul">
<li><code>HEAD</code> refers to the top of the commit log
</li>
<li><code>HEAD~1</code> refers to the commit just below it
</li>
<li><code>HEAD~2</code> refers to the commit just below that one
</li>
<li><code>HEAD~3</code> refers to <code>2b2b2169d...</code>, but we want its parent
</li>
<li><code>HEAD~4</code> refers to the parent
</li>
</ul>

<p class="footpara">
Essentially this is 0-based indexing, and <code>HEAD~4</code> is an easy way to
remember that we want to squash the top four commits.
</p></div>

<div class="footdef"><sup><a id="fn.3" name="fn.3" class="footnum" href="#fnr.3">3</a></sup> <p class="footpara">
While you could use the abbreviations, like <code>p</code> and <code>s</code>, if I
press <code>s</code> in my nifty little editor, it automatically replaces the
entire word for me&#x2026;so no, I didn&rsquo;t type anything more just for a
good screen-shot.
</p></div>


</div>
</div></div>
<div id="postamble" class="status">
<div id="bottom-section">
  <ul>
    <li>
      <a href="/formmail/mail?to=howardism" class="bottom-link" target="_blank">
        <img src="/img/footer-thin/mail.png" title="Message Me" alt="Message Me"/>
      </a>
    </li>
    <li>
      <a href="http://github.com/howardabrams" class="bottom-link" target="_blank">
        <img src="/img/footer-thin/github.png" title="My Github Projects" alt="Github"/>
      </a>
    </li>
    <li>
      <a href="http://linkedin.com/howardeabrams" class="bottom-link" target="_blank">
        <img src="/img/footer-thin/linkedin.png" title="Connect via LinkedIn" alt="LinkedIn"/>
      </a>
    </li>
    <li>
      <a href="http://youtube.com/user/howardabrams" class="bottom-link" target="_blank">
        <img src="/img/footer-thin/youtube.png" title="View my lectures and instructional videos" alt="YouTube"/>
      </a>
    </li>
    <li>
      <a href="http://twitter.com/howardabrams" class="bottom-link" target="_blank">
        <img src="/img/footer-thin/twitter.png" title="Follow me: @howardabrams" alt="Twitter"/>
      </a>
    </li>
  </ul>
</div>
</div>
</body>
</html>
